Attribute VB_Name = "modBrain"
Type mesto
  nazev As String
  polohaX As Integer
  polohaY As Integer
  sousede As String
End Type
Type cesta
  zMesta As String
  doMesta As String
  vzdalenost As Integer
  prumernaRychlost As Byte
  spotreba As Single ' pro zjednoduen
  zMestaID As Integer
  doMestaID As Integer
  flag As Boolean
End Type
Type spotreba
  rychlost As Integer
  litru As Single
End Type
Type mapa
  mesta() As mesto
  cesty() As cesta
  spotreby() As spotreba
  nactena As Boolean
End Type

Dim cID As Integer
Dim fCesty(500) As String
Function nactiMapu(FileName As String) As mapa
  Dim preMapa As mapa
  Dim s As String
  s = String(FileLen(FileName), " ")
  Open FileName For Binary As #1
  Get #1, , s
  Close
  
  Dim xmlHeader As String
  xmlHeader = "<?xml version=""1.0"" encoding=""windows-1250""?>" + vbCrLf + "<mapa>"
  If Left(s, Len(xmlHeader)) <> xmlHeader Then
  End If
   
  Dim vMapa As String
  Dim vMesta As String
  Dim vCesty As String
  Dim vSpotreby As String
  vMapa = vytah(s, "mapa")
  vMesta = vytah(vMapa, "mesta")
  vCesty = vytah(vMapa, "cesty")
  vSpotreby = vytah(vMapa, "spotreby")
  
  preMapa.mesta = nactiMesta(vMesta)
  preMapa.cesty = nactiCesty(vCesty)
  preMapa.spotreby = nactiSpotreby(vSpotreby)
  
  Dim i As Integer, j As Integer, ii As Integer
  For i = 0 To UBound(preMapa.cesty) - 1
    For j = 0 To UBound(preMapa.spotreby) - 1
      If preMapa.spotreby(j).rychlost = preMapa.cesty(i).prumernaRychlost Then preMapa.cesty(i).spotreba = preMapa.spotreby(j).litru
    Next
    For j = 0 To UBound(preMapa.mesta) - 1
      If preMapa.mesta(j).nazev = preMapa.cesty(i).zMesta Then
        preMapa.cesty(i).zMestaID = j
'        preMapa.cesty(i).zMestaX = preMapa.mesta(j).polohaX
'        preMapa.cesty(i).zMestaY = preMapa.mesta(j).polohaY
'        preMapa.mesta(j).sousede = preMapa.mesta(j).sousede + ";" + preMapa.mesta(j).nazev
      End If
      If preMapa.mesta(j).nazev = preMapa.cesty(i).doMesta Then
        preMapa.cesty(i).doMestaID = j
'        preMapa.cesty(i).doMestaX = preMapa.mesta(j).polohaX
'        preMapa.cesty(i).doMestaY = preMapa.mesta(j).polohaY
'        preMapa.mesta(j).sousede = preMapa.mesta(j).sousede + ";" + preMapa.mesta(j).nazev
      End If
    Next
  Next
  preMapa.nactena = True
  nactiMapu = preMapa
End Function
Function nactiMesta(kusMapy As String) As mesto()
  Dim preMesta() As mesto ' promnn pro ppravu mst
  ReDim preMesta(zjistiPocet(kusMapy, "mesto"))
  Dim mestoJedno As String
  For i = 0 To UBound(preMesta) - 1
    mestoJedno = vytah(kusMapy, "mesto", True)
    preMesta(i).nazev = vytah(mestoJedno, "nazev")
    preMesta(i).polohaX = vytah(mestoJedno, "polohaX")
    preMesta(i).polohaY = vytah(mestoJedno, "polohaY")
  Next
  nactiMesta = preMesta
End Function
Function nactiCesty(kusMapy As String) As cesta()
  Dim preCesty() As cesta ' promnn pro ppravu cest
  ReDim preCesty(zjistiPocet(kusMapy, "cesta"))
  Dim cestaJedna As String
  For i = 0 To UBound(preCesty) - 1
    cestaJedna = vytah(kusMapy, "cesta", True)
    preCesty(i).zMesta = vytah(cestaJedna, "z")
    preCesty(i).doMesta = vytah(cestaJedna, "do")
    preCesty(i).vzdalenost = Val(vytah(cestaJedna, "vzdalenost"))
    preCesty(i).prumernaRychlost = vytah(cestaJedna, "prumernaRychlost")
  Next
  nactiCesty = preCesty
End Function
Function nactiSpotreby(kusMapy As String) As spotreba()
  Dim preSpotreby() As spotreba ' promnn pro ppravu spoteb
  ReDim preSpotreby(zjistiPocet(kusMapy, "spotreba"))
  Dim spotrebaJedna As String
  For i = 0 To UBound(preSpotreby) - 1
    spotrebaJedna = vytah(kusMapy, "spotreba", True)
    preSpotreby(i).rychlost = vytah(spotrebaJedna, "rychlost")
    preSpotreby(i).litru = Val(vytah(spotrebaJedna, "litru"))
  Next
  nactiSpotreby = preSpotreby
End Function


Function vytah(ByRef retezec As String, tag As String, Optional cut As Boolean = False) As String
  Dim zacatek As Integer
  Dim konec As Integer
  zacatek = InStr(1, retezec, "<" + tag + ">", vbTextCompare) + Len(tag) + 2
  If zacatek > 0 Then
    konec = InStr(1, retezec, "</" + tag + ">", vbTextCompare)
    vytah = Mid(retezec, zacatek, konec - zacatek)
    If cut Then retezec = Left(retezec, zacatek - (Len(tag) + 2) - 1) + Mid(retezec, konec + (Len(tag) + 2) + 2)
  Else
    vytah = ""
  End If
End Function
Function zjistiPocet(retezec, tag)
  zjistiPocet = (Len(retezec) - Len(Replace(retezec, "<" + tag + ">", ""))) / Len("<" + tag + ">")
End Function
Function najdiTrasu(map As mapa, mid1, mid2, kr)
pc = UBound(map.cesty)
Dim cs() As Boolean
ReDim cs(pc ^ pc)
For i = 0 To UBound(cs) - 1
  If map.cesty(mistoCisla(i, 0, pc)).zMestaID = mid1 Or map.cesty(mistoCisla(i, 0, pc)).doMestaID = mid1 Then
    If map.cesty(mistoCisla(i, pc - 1, pc)).zMestaID = mid2 Or map.cesty(mistoCisla(i, pc - 1, pc)).doMestaID = mid2 Then
      cs(i) = True
    Else
      cs(i) = False
    End If
  Else
    cs(i) = False
  End If
  For j = 0 To pc
    
  Next
Next
  
'  For i = 0 To UBound(map.cesty) - 1
'    map.cesty(i).zMestaID
'  Next
End Function
Function mistoCisla(c, m, s)
mistoCisla = (c / s ^ m) Mod s
End Function
Function kudyCesta(map As mapa, mestoID) As Integer
For i = 0 To UBound(map.cesty) - 1
  If Not map.cesty(i).flag Then
    nid = -1
    If map.cesty(i).zMestaID = mestoID Then
      map.cesty(i).flag = True
      nid = map.cesty(i).doMestaID
    ElseIf map.cesty(i).doMestaID = mestoID Then
      map.cesty(i).flag = True
      nid = map.cesty(i).zMestaID
    End If
    If Not nid = -1 Then
'      kudycesta(
    End If
  End If
Next
End Function

