VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Form1"
   ClientHeight    =   4485
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   6135
   LinkTopic       =   "Form1"
   ScaleHeight     =   299
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   409
   StartUpPosition =   3  'Windows Default
   WindowState     =   2  'Maximized
   Begin VB.PictureBox picMapa 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   0  'None
      DrawWidth       =   2
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   238
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   3075
      Left            =   525
      ScaleHeight     =   205
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   343
      TabIndex        =   0
      Top             =   585
      Width           =   5145
   End
   Begin VB.Menu mnuFile 
      Caption         =   "Mapa"
      Begin VB.Menu mnuOpen 
         Caption         =   "Otevt"
      End
   End
   Begin VB.Menu mnuView 
      Caption         =   "Zobrazen"
      Begin VB.Menu mnuVidiCesty 
         Caption         =   "Viditeln cesty"
         Checked         =   -1  'True
      End
      Begin VB.Menu mnuVidiMesta 
         Caption         =   "Viditeln msta"
         Checked         =   -1  'True
      End
   End
   Begin VB.Menu mnuSearch 
      Caption         =   "Vyhledvn"
      Begin VB.Menu mnuOkoli 
         Caption         =   "Cesty do okolnch mst"
      End
      Begin VB.Menu mnuVse 
         Caption         =   "Cesty odkudkoli kamkoli"
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Declare Function FloodFill Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Long
Dim map As mapa
Dim minX As Integer, minY As Integer, maxX As Integer, maxY As Integer, km As Single

Private Sub Form_Load()
mnuOpen_Click
End Sub

Private Sub Form_Resize()
picMapa.Move 0, 0, Me.ScaleWidth, Me.ScaleHeight
NakresliMapu
End Sub

Private Sub mnuOkoli_Click()
NaplnComboMesty frmSousede.ComboMesta
frmSousede.kliknulOK = False
frmSousede.Show 1
If Not frmSousede.kliknulOK Then Exit Sub
mestoID = frmSousede.ComboMesta.ListIndex


With frmCesty.lstCesty
For i = 0 To UBound(map.cesty) - 1
  If map.cesty(i).zMestaID = mestoID Or map.cesty(i).doMestaID = mestoID Then
    If map.cesty(i).doMestaID = mestoID Then
      Set it = .ListItems.Add(1, , map.cesty(i).doMesta)
      it.SubItems(1) = map.cesty(i).zMesta
    Else
      Set it = .ListItems.Add(1, , map.cesty(i).zMesta)
      it.SubItems(1) = map.cesty(i).doMesta
    End If
    it.SubItems(2) = ""
    it.SubItems(3) = map.cesty(i).vzdalenost
    it.SubItems(4) = map.cesty(i).prumernaRychlost
    it.SubItems(5) = map.cesty(i).spotreba
    it.SubItems(6) = i
  End If

Next
End With
frmCesty.Show 1
'frmCesty.lstCesty.SelectedItem.Index
End Sub
Sub ukazCestu()

End Sub
Private Sub mnuOpen_Click()
map = nactiMapu(InputBox("zadejte cestu"))
NakresliMapu
End Sub
Private Sub NakresliMapu()
If Not map.nactena Then Exit Sub
picMapa.Cls
minX = map.mesta(0).polohaX
minY = map.mesta(0).polohaY
maxX = map.mesta(0).polohaX
maxY = map.mesta(0).polohaY
For i = 0 To UBound(map.mesta) - 1
  If map.mesta(i).polohaX < minX Then minX = map.mesta(i).polohaX
  If map.mesta(i).polohaY < minY Then minY = map.mesta(i).polohaY
  If map.mesta(i).polohaX > maxX Then maxX = map.mesta(i).polohaX
  If map.mesta(i).polohaY > maxY Then maxY = map.mesta(i).polohaY
Next
Okraj = 20
minX = minX - Okraj
minY = minY - Okraj
maxX = maxX + Okraj
maxY = maxY + Okraj

kmx = (maxX - minX) / picMapa.ScaleWidth
kmy = (maxY - minY) / picMapa.ScaleHeight
km = IIf(kmx > kmy, kmx, kmy)
With map
  If mnuVidiCesty.Checked Then
    For i = 0 To UBound(map.cesty) - 1
      NakresliCestu .mesta(map.cesty(i).zMestaID).polohaX, .mesta(map.cesty(i).zMestaID).polohaY, .mesta(map.cesty(i).doMestaID).polohaX, .mesta(map.cesty(i).doMestaID).polohaY, map.cesty(i).prumernaRychlost
    Next
  End If
  If mnuVidiMesta.Checked Then
    For i = 0 To UBound(map.mesta) - 1
      NakresliMesto map.mesta(i).polohaX, map.mesta(i).polohaY, map.mesta(i).nazev
    Next
  End If
End With
End Sub

Private Sub NakresliMesto(px, py, t)
  Dim x As Integer, y As Integer
  x = (-minX + px) / km
  y = (-minY + py) / km
  Dim c As Long
  For i = 0 To 5 Step 1
    c = RGB(0, 255 - i * 20, 255)
    picMapa.Circle (x, y), i, c
  Next
  wd = picMapa.TextWidth(t)
  hg = picMapa.TextHeight(t)
  picMapa.CurrentX = x - wd / 2
  picMapa.CurrentY = y - hg
  picMapa.Print t
End Sub
Private Sub NakresliCestu(px1, py1, px2, py2, r)
  Dim x1 As Integer, y1 As Integer, x2 As Integer, y2 As Integer
  x1 = (-minX + px1) / km
  y1 = (-minY + py1) / km
  x2 = (-minX + px2) / km
  y2 = (-minY + py2) / km
  
  c = RGB(r * 2, r * 2, 0)
  picMapa.Line (x1, y1)-(x2, y2), c
End Sub

Private Sub mnuVidiCesty_Click()
  mnuVidiCesty.Checked = Not mnuVidiCesty.Checked
  NakresliMapu
End Sub

Private Sub mnuVidiMesta_Click()
  mnuVidiMesta.Checked = Not mnuVidiMesta.Checked
  NakresliMapu
End Sub

Sub NaplnComboMesty(combo As ComboBox)
  combo.Clear
  For i = 0 To UBound(map.mesta) - 1
    combo.AddItem map.mesta(i).nazev
  Next
  combo.ListIndex = 0
End Sub
Function najdiCestu(m1, m2)
  tady = m1
  tpreskoc = 0
  For tpreskoc = 0 To UBound(map.cesty) ^ 2
    cst = ""
    Do
      preskoc = tpreskoc
      jetu = False
      For i = 0 To UBound(map.mesta) - 1
        'cst = ""
        If JeCesta(tady, i) And InStr(1, cst, CStr(i) + ",") = 0 Then
          jetu = True
          If preskoc = 0 Then
            cst = cst + CStr(i) + ","
            tady = i
            Exit For
          Else
            preskoc = preskoc - 1
          End If
        End If
      Next
    Loop Until tady = m2 Or jetu = False
    tpreskoc = tpreskoc + 1
    If jetu Then gcst = cst + vbCrLf
  Next
  MsgBox gcst
End Function
Function naplnVS() As String
  For i = 0 To UBound(map.mesta) - 1
    r = r + map.mesta(i).nazev + ","
  Next
  naplnVS = r
End Function

Function JeCesta(m1, m2)
  r = False
  For i = 0 To UBound(map.cesty)
    If (map.cesty(i).zMestaID = m1 And map.cesty(i).doMestaID = m2) Or (map.cesty(i).zMestaID = m2 And map.cesty(i).doMestaID = m1) Then r = True
  Next
  JeCesta = r
End Function

Private Sub mnuVse_Click()
  NaplnComboMesty frmKamkoli.ComboMesta
  NaplnComboMesty frmKamkoli.Combo1
  'frmKamkoli.kliknulOK = False
  frmKamkoli.Show 1
  mestoID1 = frmKamkoli.ComboMesta.ListIndex
  mestoID2 = frmKamkoli.Combo1.ListIndex
End Sub
